<!-- simplified version of https://github.com/1014156094/vue-audio-player -->
<template>
  <div class="audio-player">
    <div
      class="audio__btn-wrap"
      :style="{ 'background-image': `url(${coverImage})` }"
    >
      <div v-if="!isPlaying" class="audio__play-start" :class="{'audio__btn-wrap--cover': isCover}" @click.stop="play">
        <svg
          class="audio__play-icon"
          aria-hidden="true"
          xmlns="http://www.w3.org/2000/svg"
          width="47"
          height="47"
          viewBox="0 0 47 47"
          fill="none"
        >
          <circle cx="23.5" cy="23.5" r="23.5" fill="white" />
          <path d="M21 31V19.5V17L28 24L21 31Z" fill="#373B62" />
        </svg>
      </div>
      <div v-else class="audio__play-pause" :class="{'audio__btn-wrap--cover': isCover}" @click.stop="pause">
        <svg
          class="audio__play-icon"
          aria-hidden="true"
          xmlns="http://www.w3.org/2000/svg"
          width="47"
          height="47"
          viewBox="0 0 47 47"
          fill="none"
        >
          <circle cx="23.5" cy="23.5" r="23.5" fill="white" />
          <path d="M20 30 V 18 H 23 V 30 H 20" fill="#373B62" />
          <path d="M25 30 V 18 H 28 V 30 H 25" fill="#373B62" />
          />
        </svg>
      </div>
      <div v-show="isShowErrorMessage" class="audio__notice">
        {{ noticeMessage }}
      </div>
    </div>
    <div class="audio__interface">
      <div
        ref="audioProgressWrap"
        class="audio__progress-wrap"
        @click.stop="handleClickProgressWrap"
      >
        <div ref="audioProgress" class="audio__progress" />
        <div
          ref="audioProgressPoint"
          class="audio__progress-point"
          @panstart="handleProgressPanstart"
          @panend="handleProgressPanend"
          @panmove="handleProgressPanmove"
        />
      </div>
      <div class="audio__time-wrap">
        <div class="audio__current-time">
          {{ currentTimeFormatted }}
        </div>
        <div class="audio__duration">
          {{ durationFormatted }}
        </div>
      </div>
    </div>
    <audio
      ref="audio"
      class="audio-player__audio"
      :src="audioSrc"
      v-bind="$attrs"
      @ended="onEnded"
      @timeupdate="onTimeUpdate"
      @loadedmetadata="onLoadedmetadata"
    ></audio>
  </div>
</template>

<script>
import Core from '@any-touch/core'
import Pan from '@any-touch/pan'

export default {
  props: {
    audioSrc: {
      type: String,
      default: '',
    },
    isCover: {
      type: Boolean,
      default: false,
    },
    coverImage: {
      type: String,
      default: '',
    },
  },
  emits: [
    'pause',
    'timeupdate',
    'loadedmetadata',
    'ended',
    'progress-start',
    'progress-end',
    'progress-move',
    'progress-click',
    'playing',
    'play',
    'play-error',
  ],
  data() {
    return {
      progressInterval: 100,
      isPlaying: false,
      isDragging: false,
      isShowErrorMessage: false,
      isLoading: false,
      timer: null,
      noticeMessage: '',
      duration: '',
      currentPlayIndex: 0,
      currentTime: '',
      at: null,
    }
  },
  computed: {
    currentTimeFormatted() {
      return this.currentTime ? this.formatTime(this.currentTime) : '00:00'
    },
    durationFormatted() {
      return this.duration ? this.formatTime(this.duration) : '00:00'
    },
  },
  mounted() {
    this.at = new Core(this.$el, { preventDefault: false })
    this.at.use(Pan)
  },
  beforeUnmount() {
    this.at.destroy()
    this.pause()
  },
  methods: {
    handleShowErrorMessage(opts = {}) {
      this.noticeMessage = opts.message
      this.isShowErrorMessage = true
      window.setTimeout(() => {
        this.isShowErrorMessage = false
      }, opts.duration || 3000)
    },
    onLoadedmetadata(event) {
      this.duration = this.$refs.audio.duration
      this.$emit('loadedmetadata', event)
    },
    onTimeUpdate(event) {
      this.$emit('timeupdate', event)
    },
    formatTime(second) {
      let hour
      hour = Math.floor(second / 60)
      second = Math.floor(second % 60)
      hour += ''
      second += ''
      hour = hour.length === 1 ? '0' + hour : hour
      second = second.length === 1 ? '0' + second : second
      return hour + ':' + second
    },
    onEnded(event) {
      window.setTimeout(() => {
        this.pause()
        this.$emit('ended', event)
      }, 1000)
    },
    handleProgressPanstart(event) {
      this.isDragging = true
      this.$emit('progress-start', event)
    },
    handleProgressPanend(event) {
      this.$refs.audio.currentTime = this.currentTime
      this.play()
      this.isDragging = false
      this.$emit('progress-end', event)
    },
    handleProgressPanmove(event) {
      const pageX = event.x
      const bcr = event.target.getBoundingClientRect()
      const targetLeft = parseInt(getComputedStyle(event.target).left)
      let offsetLeft = targetLeft + (pageX - bcr.left)
      offsetLeft = Math.min(
        offsetLeft,
        this.$refs.audioProgressWrap.offsetWidth
      )
      offsetLeft = Math.max(offsetLeft, 0)
      this.setPointPosition(offsetLeft)
      this.$refs.audioProgress.style.width = offsetLeft + 'px'
      this.currentTime =
        (offsetLeft / this.$refs.audioProgressWrap.offsetWidth) * this.duration
      this.$emit('progress-move', event)
    },
    handleClickProgressWrap(event) {
      const target = event.target
      const offsetX = event.offsetX
      if (target === this.$refs.audioProgressPoint) {
        return
      }
      this.currentTime =
        (offsetX / this.$refs.audioProgressWrap.offsetWidth) * this.duration
      this.$refs.audio.currentTime = this.currentTime
      this.setPointPosition(offsetX)
      this.$refs.audioProgress.style.width = offsetX + 'px'
      this.play()
      this.$emit('progress-click', event)
    },
    setPointPosition(offsetLeft) {
      this.$refs.audioProgressPoint.style.left =
        offsetLeft - this.$refs.audioProgressPoint.offsetWidth / 2 + 'px'
    },
    playing() {
      if (this.isDragging) {
        return
      }
      const offsetLeft =
        (this.$refs.audio.currentTime / this.$refs.audio.duration) *
        this.$refs.audioProgressWrap.offsetWidth
      this.currentTime = this.$refs.audio.currentTime
      this.$refs.audioProgress.style.width = offsetLeft + 'px'
      this.setPointPosition(offsetLeft)
      this.$emit('playing')
    },
    play() {
      this.isLoading = true
      const handlePlay = () => {
        this.$refs.audio
          .play()
          .then(() => {
            this.$nextTick(() => {
              this.clearTimer()
              this.timer = window.setInterval(
                this.playing,
                this.progressInterval
              )
              this.isPlaying = true
              this.isLoading = false
            })
            this.$emit('play')
          })
          .catch((data) => {
            this.handleShowErrorMessage({
              message: data.message,
            })
            this.isLoading = false
            this.$emit('play-error', data)
          })
      }
      handlePlay()
    },
    pause() {
      this.$refs.audio.pause()
      this.$nextTick(() => {
        this.clearTimer()
        this.isPlaying = false
        this.$emit('pause')
      })
    },
    clearTimer() {
      window.clearInterval(this.timer)
      this.timer = null
    },
  },
}
</script>

<style lang="scss" scoped>
@import 'AudioPlayer.scss';
</style>
